struct EdgeVertexOutput
{
	float4 Position	: POSITION;
	float2 UV00 : TEXCOORD0;
	float2 UV01 : TEXCOORD1;
	float2 UV02 : TEXCOORD2;
	float2 UV10 : TEXCOORD3;
	float2 UV12 : TEXCOORD4;
	float2 UV20 : TEXCOORD5;
	float2 UV21 : TEXCOORD6;
	float2 UV22 : TEXCOORD7;
};

float getGray(float4 c)
{
    return(dot(c.rgb,((0.33333).xxx)));
}


float blend;
float threshhold;
sampler RT: register(s0);
float4 main_edgedetect_ps(EdgeVertexOutput IN) : COLOR
{
	// Determine original pixel color. Unfortunately we have to settle with UV00,
	// which causes a slight shift (otherwise number of TEXCOORD's is exceeded)
	float4 scnColor = tex2D(RT, IN.UV00);

	float4 CC;
	CC = tex2D(RT,IN.UV00); float g00 = getGray(CC);
	CC = tex2D(RT,IN.UV01); float g01 = getGray(CC);
	CC = tex2D(RT,IN.UV02); float g02 = getGray(CC);
	CC = tex2D(RT,IN.UV10); float g10 = getGray(CC);
	CC = tex2D(RT,IN.UV12); float g12 = getGray(CC);
	CC = tex2D(RT,IN.UV20); float g20 = getGray(CC);
	CC = tex2D(RT,IN.UV21); float g21 = getGray(CC);
	CC = tex2D(RT,IN.UV22); float g22 = getGray(CC);
	float sx = 0;
	sx -= g00;
	sx -= g01 * 2;
	sx -= g02;
	sx += g20;
	sx += g21 * 2;
	sx += g22;
	float sy = 0;
	sy -= g00;
	sy += g02;
	sy -= g10 * 2;
	sy += g12 * 2;
	sy -= g20;
	sy += g22;
	float dist = (sx*sx+sy*sy);
	float result = 1;
	if (dist>threshhold) { result = 0; }

	// Apply blending
	scnColor *= (1-blend);
	result *= blend;
	return saturate(scnColor + result.xxxx);
}
