float blend;
float sat;
sampler RT: register(s0);
float4 main_halftone_1_ps(	float2 UV : TEXCOORD0,
				float stride: TEXCOORD1,
				float dotsize: TEXCOORD2,
				float halfstride: TEXCOORD3) : COLOR
{
	float2 Pbase = UV - fmod(UV, stride);
	float2 PCenter = Pbase + halfstride;
	float4 origScnColor = tex2D(RT, UV);
	float4 tileColor = tex2D(RT, PCenter);

	float bright = length(tileColor.rgb) / 1.732; // white = (1 + 1 + 1)^.5 = 1.732
	float isinDot = length(UV - PCenter) < bright * dotsize;
	isinDot *= (tileColor * sat);

	// Apply blending
	origScnColor *= (1-blend);
	isinDot *= blend;
	return saturate(origScnColor + float4(isinDot, isinDot, isinDot, 1));
}
