float blend;
float sat;
float softness;
sampler RT: register(s0);
float4 main_halftone_3_ps(	float2 UV : TEXCOORD0, 
				float stride: TEXCOORD1,
				float dotsize: TEXCOORD2,
				float halfstride: TEXCOORD3) : COLOR
{
	float4 origScnColor = tex2D(RT, UV);
	float2 Pbase = UV - fmod(UV, stride);
	float2 PCenter = Pbase + halfstride;
	float4 tileColor = tex2D(RT, PCenter);

	float bright = length(tileColor.rgb) / 1.732; // white = (1 + 1 + 1)^.5 = 1.732
	float rad = length(UV - PCenter);
	float s = bright * dotsize;
	float isinDot = rad < s;

	float4 result = .5 - (rad / s - 1) / softness;
	result *= (tileColor * sat);

	// Apply blending
	origScnColor *= (1-blend);
	result *= blend;
	return saturate(origScnColor + result);
}