float blend;
float sat;
sampler RT: register(s0);
float4 main_halftone_4_ps(	float2 UV : TEXCOORD0, 
				float stride: TEXCOORD1,
				float dotsize: TEXCOORD2,
				float halfstride: TEXCOORD3) : COLOR
{
	float4 origScnColor = tex2D(RT, UV);
	float2 Pbase = UV - fmod(UV, stride);
	float2 PCenter = Pbase + halfstride;

	float2 CurrentCircle = PCenter + float2(0, -1) * stride;
	float4 CurrentColor = tex2D(RT, CurrentCircle);
	float bright = CurrentColor.r; //length(CurrentColor.rgb);
	float isinDot = length(UV - CurrentCircle) < bright * dotsize;
	float tileColor = isinDot;

	CurrentCircle = PCenter + float2(0, 1) * stride;
	CurrentColor = tex2D(RT, CurrentCircle);
	bright = CurrentColor.r ; //length(CurrentColor.rgb);
	isinDot = length(UV - CurrentCircle) < bright * dotsize;
	tileColor = tileColor + isinDot;

	for (int x = -1; x <= 1; x++)
	{
		CurrentCircle = PCenter + float2(x, 0) * stride;
		CurrentColor = tex2D(RT, CurrentCircle);
		bright = CurrentColor.r ; //length(CurrentColor.rgb);
		isinDot = length(UV - CurrentCircle) < bright * dotsize;
		tileColor = tileColor + isinDot;
	}

	float4 result = tileColor;
	tileColor *= (tileColor * sat);

	// Apply blending
	origScnColor *= (1-blend);
	tileColor *= blend;
	return saturate(origScnColor + tileColor);
}