float blend;
float interference;
float time_0_x;
sampler RT: register(s0);
sampler Rand: register(s1);
float4 main_ps(float2 UV: TEXCOORD0, float2 pos: TEXCOORD1) : COLOR
{
	float3 scnColor = tex2D(RT, UV).xyz;
	float average = (scnColor.r + scnColor.g + scnColor.b) / 3.0;
	float4 grey = float4(average, average, average, 1);
	float rand = tex3D(Rand, float3(1.5 * pos, time_0_x)) - 0.2;

	// Apply blending
	rand = blend * interference * rand;
	scnColor *= (1-blend);
	grey *= blend;
	return saturate(float4(scnColor.xyz, 1) + grey + rand);
}
