float blend;
float desat;
float toned;
float3 lightColor;
float3 darkColor;
sampler RT: register(s0);

float4 main_ps(float2 UV : TEXCOORD0) : COLOR
{
	float3 origScnColor = tex2D(RT, UV).xyz;
	float3 scnColor = lightColor * origScnColor;
	float3 grayXfer = float3(0.3,0.59,0.11);
	float gray = dot(grayXfer, scnColor);
	float3 muted = lerp(scnColor, gray.xxx, desat);
	float3 sepia = lerp(darkColor, lightColor, gray);
	float3 col = lerp(muted, sepia, toned);

	// Apply blending
	origScnColor *= (1-blend);
	col *= blend;
	return saturate((float4(origScnColor.xyz, 1) + float4(col, 1)));
}
