float wobbleTime;
float xScale;
float yScale;
float scroll;
float speed;
float alpha;
sampler alphaTex;
sampler fireTex;

float4 main(float2 alphaTexCoord: TEXCOORD0) : COLOR
{
	float2 fireTexCoord = alphaTexCoord;
	float origY = alphaTexCoord.y;

	// Apply wobble to alpha
	float scaledSine = xScale * sin(yScale * alphaTexCoord.y + wobbleTime);
	alphaTexCoord.x = alphaTexCoord.x + scaledSine;

	// Apply wobble to fire
	fireTexCoord.x = fireTexCoord.x - scaledSine;

	// Apply scroll
	float y = origY + scroll * speed;

	alphaTexCoord.y = y;
	fireTexCoord.y = y;

	float4 fireCol = tex2D(fireTex, fireTexCoord);
	float4 alphaCol = tex2D(alphaTex, alphaTexCoord);
	float p = pow (origY, alpha/origY);
	fireCol.a *= alphaCol.a - 1 + p;
	return fireCol;
}
