float time;
float burnSpeed;
float randomnessRate;
float sideFade;
float sideFadeSharpness;
float wobbleScale;
float xScale;
float yScale;
float yFade;

sampler Noise: register(s0);
sampler Flame: register(s1);

float4 main(float2 texCoord: TEXCOORD0) : COLOR 
{
	// Wobble for the noise to get a more realistic appearance
	float wobbX = 2 * cos(6 * texCoord.x + time);
	float wobbY = 7 * (1 - texCoord.y) * (1 - texCoord.y);
	float wobble = sin(time + wobbX + wobbY);

	float3 coord;
	// Wobble more in the flames than at the base
	coord.x = xScale * texCoord.x + wobbleScale * (texCoord.y - 1) * wobble;

	// Create an upwards movement
	coord.y = yScale * texCoord.y - burnSpeed * time;

	// Move in Z to get some randomness
	coord.z = randomnessRate * time;
	float noisy = tex3D(Noise, coord);

	// Define the shape of the fire
	float t = sideFadeSharpness * (1 - sideFade * texCoord.x * texCoord.x);

	// Get the color out of it all
	float heat = saturate(t + noisy - yFade * texCoord.y);
	float4 flame = tex1D(Flame, heat);
	return flame;
}
